import { Component, EventEmitter, Input, Output, ViewChild, TemplateRef } from "@angular/core";
import { TreeviewI18n } from "./treeview-i18n";
import { TreeviewConfig } from "./treeview-config";
import { TreeviewComponent } from "./treeview.component";
import { DropdownDirective } from "./dropdown.directive";
import * as i0 from "@angular/core";
import * as i1 from "./treeview-i18n";
import * as i2 from "./treeview-config";
import * as i3 from "./dropdown.directive";
import * as i4 from "./dropdown-toggle.directive";
import * as i5 from "@angular/common";
import * as i6 from "./dropdown-menu.directive";
import * as i7 from "./treeview.component";
function DropdownTreeviewComponent_span_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r52 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r52.getText());
} }
var DropdownTreeviewComponent = /** @class */ (function () {
    function DropdownTreeviewComponent(i18n, defaultConfig) {
        this.i18n = i18n;
        this.defaultConfig = defaultConfig;
        this.buttonClass = "btn-outline-secondary";
        this.selectedChange = new EventEmitter(true);
        this.filterChange = new EventEmitter();
        this.config = this.defaultConfig;
    }
    DropdownTreeviewComponent.prototype.getText = function () {
        return this.treeviewComponent && this.treeviewComponent.selection
            ? this.i18n.getText(this.treeviewComponent.selection)
            : "";
    };
    DropdownTreeviewComponent.prototype.onSelectedChange = function (values) {
        this.selectedChange.emit(values);
    };
    DropdownTreeviewComponent.prototype.onFilterChange = function (text) {
        this.filterChange.emit(text);
    };
    DropdownTreeviewComponent.ɵfac = function DropdownTreeviewComponent_Factory(t) { return new (t || DropdownTreeviewComponent)(i0.ɵɵdirectiveInject(i1.TreeviewI18n), i0.ɵɵdirectiveInject(i2.TreeviewConfig)); };
    DropdownTreeviewComponent.ɵcmp = i0.ɵɵdefineComponent({ type: DropdownTreeviewComponent, selectors: [["ngx-dropdown-treeview"]], viewQuery: function DropdownTreeviewComponent_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵstaticViewQuery(TreeviewComponent, true);
            i0.ɵɵstaticViewQuery(DropdownDirective, true);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.treeviewComponent = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.dropdownDirective = _t.first);
        } }, inputs: { buttonClass: "buttonClass", headerTemplate: "headerTemplate", itemTemplate: "itemTemplate", items: "items", config: "config" }, outputs: { selectedChange: "selectedChange", filterChange: "filterChange" }, decls: 6, vars: 6, consts: [["ngxDropdown", "", 1, "dropdown"], ["type", "button", "role", "button", "ngxDropdownToggle", "", 1, "btn", 3, "ngClass"], [4, "ngIf"], ["ngxDropdownMenu", "", "aria-labelledby", "dropdownMenu", 3, "click"], [1, "dropdown-container"], [3, "config", "headerTemplate", "items", "itemTemplate", "selectedChange", "filterChange"]], template: function DropdownTreeviewComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵelementStart(1, "button", 1);
            i0.ɵɵtemplate(2, DropdownTreeviewComponent_span_2_Template, 2, 1, "span", 2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(3, "div", 3);
            i0.ɵɵlistener("click", function DropdownTreeviewComponent_Template_div_click_3_listener($event) { return $event.stopPropagation(); });
            i0.ɵɵelementStart(4, "div", 4);
            i0.ɵɵelementStart(5, "ngx-treeview", 5);
            i0.ɵɵlistener("selectedChange", function DropdownTreeviewComponent_Template_ngx_treeview_selectedChange_5_listener($event) { return ctx.onSelectedChange($event); })("filterChange", function DropdownTreeviewComponent_Template_ngx_treeview_filterChange_5_listener($event) { return ctx.onFilterChange($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngClass", ctx.buttonClass);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.items && ctx.items.length);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("config", ctx.config)("headerTemplate", ctx.headerTemplate)("items", ctx.items)("itemTemplate", ctx.itemTemplate);
        } }, directives: [i3.DropdownDirective, i4.DropdownToggleDirective, i5.NgClass, i5.NgIf, i6.DropdownMenuDirective, i7.TreeviewComponent], styles: [".dropdown[_ngcontent-%COMP%] {\n      width: 100%;\n      display: inline-block;\n    }\n\n    .dropdown[_ngcontent-%COMP%]   button[_ngcontent-%COMP%] {\n      width: 100%;\n      margin-right: .9rem;\n      text-align: left;\n      overflow: hidden;\n      padding-right: 30px;\n      text-overflow: ellipsis;\n    }\n\n    .dropdown[_ngcontent-%COMP%]   button[_ngcontent-%COMP%]::after {\n      position: absolute;\n      right: .6rem;\n      margin-top: .6rem;\n    }\n\n    .dropdown[_ngcontent-%COMP%]   .dropdown-menu[_ngcontent-%COMP%]   .dropdown-container[_ngcontent-%COMP%] {\n      padding: 0 .6rem;\n    }"] });
    return DropdownTreeviewComponent;
}());
export { DropdownTreeviewComponent };
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(DropdownTreeviewComponent, [{
        type: Component,
        args: [{
                selector: "ngx-dropdown-treeview",
                template: "\n    <div class=\"dropdown\" ngxDropdown>\n      <button\n        class=\"btn\"\n        [ngClass]=\"buttonClass\"\n        type=\"button\"\n        role=\"button\"\n        ngxDropdownToggle\n      >\n        <span *ngIf=\"items && items.length\">{{ getText() }}</span>\n      </button>\n      <div\n        ngxDropdownMenu\n        aria-labelledby=\"dropdownMenu\"\n        (click)=\"$event.stopPropagation()\"\n      >\n        <div class=\"dropdown-container\">\n          <ngx-treeview\n            [config]=\"config\"\n            [headerTemplate]=\"headerTemplate\"\n            [items]=\"items\"\n            [itemTemplate]=\"itemTemplate\"\n            (selectedChange)=\"onSelectedChange($event)\"\n            (filterChange)=\"onFilterChange($event)\"\n          >\n          </ngx-treeview>\n        </div>\n      </div>\n    </div>\n  ",
                styles: ["\n    .dropdown {\n      width: 100%;\n      display: inline-block;\n    }\n\n    .dropdown button {\n      width: 100%;\n      margin-right: .9rem;\n      text-align: left;\n      overflow: hidden;\n      padding-right: 30px;\n      text-overflow: ellipsis;\n    }\n\n    .dropdown button::after {\n      position: absolute;\n      right: .6rem;\n      margin-top: .6rem;\n    }\n\n    .dropdown .dropdown-menu .dropdown-container {\n      padding: 0 .6rem;\n    }\n  "]
            }]
    }], function () { return [{ type: i1.TreeviewI18n }, { type: i2.TreeviewConfig }]; }, { buttonClass: [{
            type: Input
        }], headerTemplate: [{
            type: Input
        }], itemTemplate: [{
            type: Input
        }], items: [{
            type: Input
        }], config: [{
            type: Input
        }], selectedChange: [{
            type: Output
        }], filterChange: [{
            type: Output
        }], treeviewComponent: [{
            type: ViewChild,
            args: [TreeviewComponent, { static: true }]
        }], dropdownDirective: [{
            type: ViewChild,
            args: [DropdownDirective, { static: true }]
        }] }); })();
//# sourceMappingURL=dropdown-treeview.component.js.map